<template>
  <div>
    <v-card>
      <v-toolbar color="grey" dark>
        <v-toolbar-title class="white--text">
          GRUPOS PARA ACCEDER A DOCUMENTOS PUBLICADOS
          <v-btn
            fab
            class="white--text"
            color="primary"
            bottom
            right
            absolute
            :to="{ name: 'modelo_negocio_accesos_grupos_nuevo' }"
          >
            <v-icon>mdi-plus</v-icon>
          </v-btn>
        </v-toolbar-title>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          label="Buscar"
          flat
          class="mr-16"
          dark
          solo-inverted
          append-icon="mdi-magnify"
          hide-details
          clear-icon="mdi-close-circle-outline"
        ></v-text-field>
      </v-toolbar>
      <v-list three-line subheader>
        <v-subheader>GRUPOS</v-subheader>
        <v-list-item-group v-model="selectedItem" color="primary">
          <v-divider />
          <template v-for="(item, indexItem) in searchResult">
            <v-list-item :key="indexItem" link>
              <v-list-item-avatar>
                <v-icon color="grey lighten-1" x-large
                  >mdi-account-group-outline</v-icon
                >
              </v-list-item-avatar>
              <v-list-item-content>
                <v-list-item-title>
                  <router-link
                    class="text-decoration-underline"
                    :to="toEditGroup(item)"
                  >
                    {{ item.descripcion }}
                  </router-link>
                </v-list-item-title>
                <v-list-item-subtitle>
                  <v-badge
                    color="primary"
                    inline
                    overlap
                    :value="item.totalDocumentos"
                    :content="item.totalDocumentos"
                  >
                    <v-icon color="grey lighten-1"
                      >mdi-file-document-multiple-outline</v-icon
                    >
                    <router-link
                      class="text-decoration-underline"
                      :to="toGroupDocumentos(item)"
                    >
                      Documentos
                    </router-link>
                  </v-badge>
                </v-list-item-subtitle>
                <v-list-item-subtitle>
                  <v-badge
                    color="primary"
                    inline
                    overlap
                    :value="item.totalUsuarios"
                    :content="item.totalUsuarios"
                  >
                    <v-icon color="grey lighten-1">
                      mdi-account-multiple-outline
                    </v-icon>
                    <router-link
                      class="text-decoration-underline"
                      :to="toGroupUsuarios(item)"
                    >
                      Usuarios
                    </router-link>
                  </v-badge>
                </v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      class="white--text"
                      v-bind="attrs"
                      v-on="on"
                      fab
                      small
                      color="primary"
                      @click="deleteGrupo(item)"
                    >
                      <v-icon>mdi-delete</v-icon>
                    </v-btn>
                  </template>
                  <span>Borrar grupo</span>
                </v-tooltip>
              </v-list-item-action>
            </v-list-item>
            <v-divider :key="'divider-' + indexItem" />
          </template>
        </v-list-item-group>
      </v-list>
    </v-card>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.custom-speed-dial.v-speed-dial--direction-left .v-speed-dial__list {
  right: 60%;
}
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}
div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import moment from "moment";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-ListaGrupos",
  data: (vm) => ({
    data: [],
    loading: false,
    caseSensitive: false,
    search: null,
    selectedItem: null,
  }),
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchResult() {
      let tempData = this.data;
      if (this.search != "" && this.search) {
        tempData = tempData.filter((item) => {
          return item.descripcion
            .toUpperCase()
            .includes(this.search.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.descripcion.toLowerCase();
          let fb = b.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    formatDate(date) {
      return moment(date).format("DD-MM-YYYY");
    },
    toEditGroup(grupo) {
      return {
        name: "modelo_negocio_accesos_grupos_edicion",
        params: {
          grupo: this.serviceCommons.objectToBase64(grupo),
        },
      };
    },
    toGroupDocumentos(grupo) {
      return {
        name: "modelo_negocio_accesos_grupos_edicion",
        params: {
          grupo: this.serviceCommons.objectToBase64(grupo),
        },
        query: {
          documentos: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    toGroupUsuarios(grupo) {
      return {
        name: "modelo_negocio_accesos_grupos_edicion",
        params: {
          grupo: this.serviceCommons.objectToBase64(grupo),
        },
        query: {
          usuarios: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    deleteGrupo(grupo) {
      axios
        .delete("/modelo-negocio/accesos/grupos/v1/" + grupo.idGrupo)
        .then((response) => {
          this.getGrupos();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getGrupos() {
      const self = this;
      this.loading = true;
      axios("/modelo-negocio/accesos/grupos/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            self.data = data.resultado.grupos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          self.loading = false;
        });
    },
  },
  created() {
    this.getGrupos();
  },
};
</script>
